Imports System.Security.Cryptography
Imports System.Text
Imports System.IO

#Const USE_BASE64 = False

'
' A Class to encrypt/decrypt the connection strings in the config file.
' Note: I don't like "Base 64" string format, so I use hex strings instead
'
Public Class Crypt

    ' Hey... it's not like I'm trying to keep spies out... I'm just
    ' trying to keep the casual user from poking around.
    Private TheKey() As Byte = {&H0, &H11, &H22, &H33, &H44, &H55, &H66, &H77}
    Private Vector() As Byte = {&H88, &H99, &HAA, &HBB, &HCC, &HDD, &HEE, &HFF}

    Public Sub New()
        Dim AssmemblyName As String
        Dim SaltChars() As Char
        Dim Ending As Integer

        AssmemblyName = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name
        SaltChars = AssmemblyName.ToCharArray

        Ending = CInt(IIf(SaltChars.Length < 5, SaltChars.Length - 1, 4))
        For i As Integer = 0 To Ending
            TheKey(i) = TheKey(i) And Convert.ToByte(SaltChars(i))
        Next
    End Sub

    Public Sub New(ByVal AssemblyName As String)
        Dim SaltChars() As Char
        Dim Ending As Integer

        SaltChars = AssemblyName.ToCharArray
        Ending = CInt(IIf(SaltChars.Length < 5, SaltChars.Length - 1, 4))

        For i As Integer = 0 To Ending
            TheKey(i) = TheKey(i) And Convert.ToByte(SaltChars(i))
        Next
    End Sub

    '
    ' A simple DES string Encrytion routine
    '
    Public Function Encrypt(ByVal message As String) As String
        Dim des As New DESCryptoServiceProvider
        Dim ms As New MemoryStream
        Dim in_buf(), out_buf() As Byte

        ' a quick sanity check
        If message = "" Then
            Return ""
        End If

        ' put the cleartext into the input buffer
        in_buf = Encoding.ASCII.GetBytes(message)

        Try
            ' create an DES Encryptor output stream
            Dim crStream As New CryptoStream(ms, des.CreateEncryptor(TheKey, Vector), CryptoStreamMode.Write)
            crStream.Write(in_buf, 0, in_buf.Length)
            crStream.FlushFinalBlock()

            ' read the ciphertext into the output array
            out_buf = ms.ToArray

            ms.Close()
            crStream.Close()
        Catch ex As System.Security.Cryptography.CryptographicException
            ' if encryption fails, just silently return an empty string
            Return ""
        End Try

#If USE_BASE64 Then
        Return Convert.ToBase64String(out_buf)
#Else
        Return BitConverter.ToString(out_buf).Replace("-", "")
#End If
    End Function

    '
    ' A simple DES decryption routine
    '
    Public Function Decrypt(ByVal message As String) As String
        Dim des As New DESCryptoServiceProvider
        Dim ms As New MemoryStream
        Dim in_buf(), out_buf() As Byte

        ' a quick sanity check
        If message = "" Then
            Return ""
        End If

        ' put the ciphertext into the input buffer
        Try
#If USE_BASE64 Then
            in_buf = Convert.FromBase64String(message)
#Else
            ' There's no easy way to convert a hex byte string back into
            ' a byte array, so we have parse each byte
            ReDim in_buf((message.Length \ 2) - 1)
            For i As Integer = 0 To in_buf.Length - 1
                in_buf(i) = Byte.Parse(message.Substring(i * 2, 2), Globalization.NumberStyles.HexNumber)
            Next
#End If
        Catch ex As System.FormatException
            ' if the string isn't in the correct format, then just silently fail
            Return ""
        End Try

        Try
            ' Create an DES Decryptor stream
            Dim crStream As New CryptoStream(ms, des.CreateDecryptor(TheKey, Vector), CryptoStreamMode.Write)
            crStream.Write(in_buf, 0, in_buf.Length)
            crStream.FlushFinalBlock()

            ' read the cleartext into the output array
            out_buf = ms.ToArray

            ms.Close()
            crStream.Close()
        Catch ex As System.Security.Cryptography.CryptographicException
            ' if decryption fails, just silently return an empty string
            Return ""
        End Try

        Return Encoding.ASCII.GetString(out_buf)
    End Function
End Class
