Imports Microsoft.Win32

'
' Class to get the name of the remotely logged in user
'

Public Class GetUser

#Region "API Region"
    'BOOL LookupAccountSid(
    '  LPCTSTR lpSystemName,
    '  PSID lpSid,
    '  LPTSTR lpName,
    '  LPDWORD cchName,
    '  LPTSTR lpReferencedDomainName,
    '  LPDWORD cchReferencedDomainName,
    '  PSID_NAME_USE peUse
    ');
    Private Declare Auto Function LookupAccountSid Lib "advapi32.dll" ( _
        ByVal lpSystemName As String, _
        ByVal lpSid As IntPtr, _
        ByVal lpName As String, _
        ByRef cchName As Integer, _
        ByVal lpReferenceDomainName As String, _
        ByRef cchReferencedDomainName As Integer, _
        ByRef peUse As Integer _
    ) As Boolean

    'BOOL ConvertStringSidToSid(
    '  LPCTSTR StringSid,
    '  PSID* Sid
    ');
    Private Declare Auto Function ConvertStringSidToSid Lib "advapi32.dll" ( _
        ByVal StringSid As String, _
        ByRef Sid As IntPtr _
    ) As Boolean

    Private Const NAME_SIZE As Integer = 64
#End Region

    Public Function GetRemoteUser(ByVal RemotePC As String) As String
        Dim reg_hku, key, subkey As RegistryKey
        Dim user, keyname, CurKey, UserName, DomainName As String
        Dim name_len, domain_len, peUse As Integer
        Dim got_it As Boolean
        Dim Sid As IntPtr

        CurKey = ""
        user = "Error"
        Try
            reg_hku = RegistryKey.OpenRemoteBaseKey(RegistryHive.Users, RemotePC)
            If Not IsNothing(reg_hku) Then
                ' Find the User key that has "Volatile Environment"... that's
                ' either the current user or the last user logged in.
                got_it = False
                For Each keyname In reg_hku.GetSubKeyNames()
                    key = reg_hku.OpenSubKey(keyname, False)
                    If Not IsNothing(key) Then
                        If Array.IndexOf(key.GetSubKeyNames(), "Volatile Environment") >= 0 Then
                            CurKey = keyname
                            ' for WinXP's alternate login, we must check to
                            ' see if the CLIENTNAME is "Console"
                            subkey = key.OpenSubKey("Volatile Environment")
                            If Not IsNothing(subkey) Then
                                If subkey.GetValue("CLIENTNAME", "").ToString = "Console" Then
                                    got_it = True
                                End If
                                subkey.Close()
                            End If
                        End If
                        key.Close()
                        If got_it Then
                            Exit For
                        End If
                    End If
                Next
                reg_hku.Close()
            End If

            ' Nope, didn't find anything
            If CurKey = "" Then
                Return "Nobody"
            End If

            ' In rare cases, the user's registry hive is still loaded.  So
            ' to test if there is anybody currently logged on, we see if
            ' the remote PC has an explorer.exe process running
            If Process.GetProcessesByName("explorer", RemotePC).Length = 0 Then
                Return "Nobody"
            End If

            ' Now let's get the logon name from the string version of the
            ' Sid (which is the registry key name)
            If ConvertStringSidToSid(CurKey, Sid) = False Then
                Return "Error"
            End If

            name_len = NAME_SIZE
            domain_len = NAME_SIZE
            UserName = Space(name_len)
            DomainName = Space(domain_len)

            ' look up the Account associated with that SID
            If LookupAccountSid(RemotePC, Sid, UserName, name_len, DomainName, domain_len, peUse) = False Then
                Return "Error"
            End If
            If domain_len > 0 Then
                user = Left(DomainName, domain_len) & "\" & Left(UserName, name_len)
            Else
                user = RemotePC & "\" & Left(UserName, name_len)
            End If
        Catch ex As Exception
            Return "Error"
        End Try

        Return user
    End Function
End Class
