Imports System.IO
Imports System.management
Imports System.Configuration.ConfigurationSettings

'
' The only practical way to detect the idle time of a remote computer is to run
' an application on that computer.  Ideally this would be done with a .Net
' remoting object, but that would require a bit of planning/installation.  So,
' the next best thing is an application that determines the idle time, writes
' it to a known location, and then we read that file.  Geez...
'
Public Class IdleTime

    Public Function GetIdleTime(ByVal PC As String) As TimeSpan
        Dim wmi As ManagementClass
        Dim wmi_in, wmi_out As ManagementBaseObject
        Dim ret As Integer
        Dim ans As TimeSpan

        ' a bit of sanity checking...
        If Not File.Exists(ConvUNC(PC, "C:\Utils\IdleTime.exe")) Then
            Throw New ApplicationException("IdleTime.exe is not installed")
        End If

        wmi = New ManagementClass("\\" & PC & "\root\cimv2:Win32_Process")
        wmi_in = wmi.GetMethodParameters("Create")
        wmi_in("CommandLine") = "cmd /c C:\Utils\IdleTime.exe > C:\Utils\Idle.txt"
        wmi_out = wmi.InvokeMethod("Create", wmi_in, Nothing)
        ret = Convert.ToInt32(wmi_out("returnValue"))
        If ret <> 0 Then
            Throw New ApplicationException("Create method error " & ret)
        End If

        Dim sr As StreamReader
        Dim err_count As Integer
        Do While True
            Try
                System.Threading.Thread.Sleep(500)
                sr = File.OpenText(ConvUNC(PC, "C:\Utils\idle.txt"))
                ret = CInt(sr.ReadLine)
                sr.Close()
                Exit Do
            Catch ex As Exception
                ' it might take a while for the information in the file to
                ' appear, so we keep trying
                err_count += 1
                If err_count >= 4 Then
                    Throw New ApplicationException("Got no output from IdleTime command", ex)
                End If
            End Try
        Loop

        ans = TimeSpan.FromSeconds(ret)
        Return ans
    End Function

    '
    ' Convert a "local" filename to a UNC remote filename
    '
    Private Function ConvUNC(ByVal RemotePC As String, ByVal Filename As String) As String
        Dim ans As String

        If RemotePC = "" Then
            Return Filename
        End If

        ans = ""
        If Len(Filename) > 2 Then
            ans = "\\" & RemotePC & "\" & Filename.Substring(0, 1) & "$" & Filename.Substring(2)
        End If
        Return ans
    End Function
End Class
